from django.test import TestCase

from core import models
from core.models import StudentInfo
from util.factories import GradyUserFactory


class FactoryTestCase(TestCase):

    factory = GradyUserFactory()

    def test_make_student(self):

        user = self.factory.make_student()

        self.assertEqual(StudentInfo.objects.count(), 1)
        self.assertEqual(user.student.exam, None)
        self.assertEqual(len(str(user.student.matrikel_no)), 8)

    def test_can_create_reviewer(self):
        self.assertTrue(isinstance(self.factory.make_reviewer(),
                                   models.UserAccount))

    def test_reviewer_appears_in_query_set(self):
        self.assertIn(self.factory.make_reviewer(),
                      models.UserAccount.objects.all())

    def test_can_create_tutor(self):
        self.assertIn(self.factory.make_tutor(),
                      models.UserAccount.objects.all())

    def test_can_create_student_user(self):
        self.assertIn(self.factory.make_student(),
                      models.UserAccount.objects.all())

    def test_can_create_student_info(self):
        self.assertIn(self.factory.make_student().student,
                      StudentInfo.objects.all())
