import Vue from 'vue'
import App from './App.vue'
import router from './router/index'
import store from './store/store'
import Vuetify from 'vuetify'
import Notifications from 'vue-notification'
import Clipboard from 'v-clipboard'

import 'vuetify/dist/vuetify.min.css'
import 'highlight.js/styles/atom-one-light.css'

Vue.use(Vuetify)
Vue.use(Clipboard)
Vue.use(Notifications)

Vue.config.productionTip = false

export default new Vue({
  router,
  store,
  render: h => h(App)
}).$mount('#app')
