
function initialState () {
  return {
    sideBarCollapsed: false,
    darkMode: false,
    darkModeUnlocked: false,
    showJumbotron: true
  }
}

export const uiMut = Object.freeze({
  SET_SIDEBAR_COLLAPSED: 'SET_SIDEBAR_COLLAPSED',
  SET_DARK_MODE: 'SET_DARK_MODE',
  SET_DARK_MODE_UNLOCKED: 'SET_DARK_MODE_UNLOCKED',
  SET_SHOW_JUMBOTRON: 'SET_SHOW_JUMBOTRON'
})

const ui = {
  state: initialState(),
  mutations: {
    [uiMut.SET_SIDEBAR_COLLAPSED] (state, collapsed) {
      state.sideBarCollapsed = collapsed
    },
    [uiMut.SET_DARK_MODE] (state, val) {
      state.darkMode = val
    },
    [uiMut.SET_DARK_MODE_UNLOCKED] (state, val) {
      state.darkModeUnlocked = val
    },
    [uiMut.SET_SHOW_JUMBOTRON] (state, val) {
      state.showJumbotron = val
    }
  }
}

export default ui
